---
title: OpenSearch API Reference
product: Databases
url: https://docs.digitalocean.com/reference/api/reference/databases/
---

> **For AI agents:** The documentation index is at [https://docs.digitalocean.com/llms.txt](https://docs.digitalocean.com/llms.txt). Markdown versions of pages use the same URL with `index.html.md` in place of the HTML page (for example, append `index.html.md` to the directory path instead of opening the HTML document).

# OpenSearch API Reference

[View full API reference](https://docs.digitalocean.com/reference/api/reference/index.html.md)

DigitalOcean's [managed database service](https://docs.digitalocean.com/products/databases) simplifies the creation and management of highly available database clusters. Currently, it offers support for [PostgreSQL](http://docs.digitalocean.com/products/databases/postgresql/), [Caching](https://docs.digitalocean.com/products/databases/redis/index.html.md), [Valkey](https://docs.digitalocean.com/products/databases/valkey/index.html.md), [MySQL](https://docs.digitalocean.com/products/databases/mysql/index.html.md), [MongoDB](https://docs.digitalocean.com/products/databases/mongodb/index.html.md), and [OpenSearch](https://docs.digitalocean.com/products/databases/opensearch/index.html.md).

By sending requests to the `/v2/databases` endpoint, you can list, create, or delete database clusters as well as scale the size of a cluster, add or remove read-only replicas, and manage other configuration details.

Database clusters may be deployed in a multi-node, high-availability configuration. If your machine type is above the basic nodes, your node plan is above the smallest option, or you are running MongoDB, you may additionally include up to two standby nodes in your cluster.

The size of individual nodes in a database cluster is represented by a human-readable slug, which is used in some of the following requests. Each slug denotes the node's identifier, CPU count, and amount of RAM, in that order.

For a list of currently available database slugs and options, use the `/v2/databases/options` endpoint or use the `doctl databases options` [command](https://docs.digitalocean.com/reference/doctl/reference/databases/options).

Base URL `https://api.digitalocean.com`

## Endpoints

- **GET** [List Database Options](#databases_list_options)
- **GET** [List All Database Clusters](#databases_list_clusters)
- **POST** [Create a New Database Cluster](#databases_create_cluster)
- **GET** [Retrieve an Existing Database Cluster](#databases_get_cluster)
- **DELETE** [Destroy a Database Cluster](#databases_destroy_cluster)
- **GET** [Retrieve an Existing Database Cluster Configuration](#databases_get_config)
- **PATCH** [Update the Database Configuration for an Existing Database](#databases_patch_config)
- **GET** [Retrieve the Public Certificate](#databases_get_ca)
- **GET** [Retrieve the Status of an Online Migration](#databases_get_migrationStatus)
- **PUT** [Start an Online Migration](#databases_update_onlineMigration)
- **DELETE** [Stop an Online Migration](#databases_delete_onlineMigration)
- **PUT** [Migrate a Database Cluster to a New Region](#databases_update_region)
- **PUT** [Resize a Database Cluster](#databases_update_clusterSize)
- **GET** [List Firewall Rules (Trusted Sources) for a Database Cluster](#databases_list_firewall_rules)
- **PUT** [Update Firewall Rules (Trusted Sources) for a Database](#databases_update_firewall_rules)
- **GET** [Retrieve DO Settings for a Database Cluster](#databases_get_do_settings)
- **PUT** [Update DO Settings for a Database Cluster](#databases_update_do_settings)
- **PUT** [Configure a Database Cluster's Maintenance Window](#databases_update_maintenanceWindow)
- **PUT** [Start Database Maintenance](#databases_install_update)
- **GET** [List Backups for a Database Cluster](#databases_list_backups)
- **GET** [List All Read-only Replicas](#databases_list_replicas)
- **POST** [Create a Read-only Replica](#databases_create_replica)
- **GET** [List all Events Logs](#databases_list_events_logs)
- **GET** [Retrieve an Existing Read-only Replica](#databases_get_replica)
- **DELETE** [Destroy a Read-only Replica](#databases_destroy_replica)
- **PUT** [Promote a Read-only Replica to become a Primary Cluster](#databases_promote_replica)
- **GET** [List all Database Users](#databases_list_users)
- **POST** [Add a Database User](#databases_add_user)
- **GET** [Retrieve an Existing Database User](#databases_get_user)
- **PUT** [Update a Database User](#databases_update_user)
- **DELETE** [Remove a Database User](#databases_delete_user)
- **POST** [Reset a Database User's Password or Authentication Method](#databases_reset_auth)
- **GET** [List All Databases](#databases_list)
- **POST** [Add a New Database](#databases_add)
- **GET** [Retrieve an Existing Database](#databases_get)
- **DELETE** [Delete a Database](#databases_delete)
- **GET** [List Connection Pools (PostgreSQL)](#databases_list_connectionPools)
- **POST** [Add a New Connection Pool (PostgreSQL)](#databases_add_connectionPool)
- **GET** [Retrieve Existing Connection Pool (PostgreSQL)](#databases_get_connectionPool)
- **PUT** [Update Connection Pools (PostgreSQL)](#databases_update_connectionPool)
- **DELETE** [Delete a Connection Pool (PostgreSQL)](#databases_delete_connectionPool)
- **GET** [Retrieve the Eviction Policy for a Caching or Valkey Cluster](#databases_get_evictionPolicy)
- **PUT** [Configure the Eviction Policy for a Caching or Valkey Cluster](#databases_update_evictionPolicy)
- **GET** [Retrieve the SQL Modes for a MySQL Cluster](#databases_get_sql_mode)
- **PUT** [Update SQL Mode for a Cluster](#databases_update_sql_mode)
- **PUT** [Upgrade Major Version for a Database](#databases_update_major_version)
- **GET** [Retrieve Autoscale Configuration for a Database Cluster](#databases_get_autoscale)
- **PUT** [Configure Autoscale Settings for a Database Cluster](#databases_update_autoscale)
- **GET** [List Topics for a Kafka Cluster](#databases_list_kafka_topics)
- **POST** [Create Topic for a Kafka Cluster](#databases_create_kafka_topic)
- **GET** [Get Topic for a Kafka Cluster](#databases_get_kafka_topic)
- **PUT** [Update Topic for a Kafka Cluster](#databases_update_kafka_topic)
- **DELETE** [Delete Topic for a Kafka Cluster](#databases_delete_kafka_topic)
- **GET** [List Logsinks for a Database Cluster](#databases_list_logsink)
- **POST** [Create Logsink for a Database Cluster](#databases_create_logsink)
- **GET** [Get Logsink for a Database Cluster](#databases_get_logsink)
- **PUT** [Update Logsink for a Database Cluster](#databases_update_logsink)
- **DELETE** [Delete Logsink for a Database Cluster](#databases_delete_logsink)
- **GET** [List Schemas for Kafka Cluster](#databases_list_kafka_schemas)
- **POST** [Create Schema Registry for Kafka Cluster](#databases_create_kafka_schema)
- **GET** [Get a Kafka Schema by Subject Name](#databases_get_kafka_schema)
- **DELETE** [Delete a Kafka Schema by Subject Name](#databases_delete_kafka_schema)
- **GET** [Get Kafka Schema by Subject Version](#databases_get_kafka_schema_version)
- **GET** [Retrieve Schema Registry Configuration for a kafka Cluster](#databases_get_kafka_schema_config)
- **PUT** [Update Schema Registry Configuration for a kafka Cluster](#databases_update_kafka_schema_config)
- **GET** [Retrieve Schema Registry Configuration for a Subject of kafka Cluster](#databases_get_kafka_schema_subject_config)
- **PUT** [Update Schema Registry Configuration for a Subject of kafka Cluster](#databases_update_kafka_schema_subject_config)
- **GET** [Retrieve Database Clusters' Metrics Endpoint Credentials](#databases_get_cluster_metrics_credentials)
- **PUT** [Update Database Clusters' Metrics Endpoint Credentials](#databases_update_cluster_metrics_credentials)
- **GET** [List Indexes for a OpenSearch Cluster](#databases_list_opeasearch_indexes)
- **DELETE** [Delete Index for OpenSearch Cluster](#databases_delete_opensearch_index)

## GET List Database Options

`/v2/databases/options`

**Authorizations: bearer_auth (1 scope)**

Http: Bearer

Required scopes: database:read

### OAuth Authentication

In order to interact with the DigitalOcean API, you or your application must authenticate.

The DigitalOcean API handles this through OAuth, an open standard for authorization. OAuth allows you to delegate access to your account. Scopes can be used to grant full access, read-only access, or access to a specific set of endpoints.

You can generate an OAuth token by visiting the [Apps & API](https://cloud.digitalocean.com/account/api/tokens) section of the DigitalOcean control panel for your account.

An OAuth token functions as a complete authentication request. In effect, it acts as a substitute for a username and password pair.

Because of this, it is absolutely **essential** that you keep your OAuth tokens secure. In fact, upon generation, the web interface will only display each token a single time in order to prevent the token from being compromised.

DigitalOcean access tokens begin with an identifiable prefix in order to distinguish them from other similar tokens.

- `dop_v1_` for personal access tokens generated in the control panel
- `doo_v1_` for tokens generated by applications using [the OAuth flow](https://docs.digitalocean.com/reference/api/oauth-api/index.html.md)
- `dor_v1_` for OAuth refresh tokens

#### Scopes

Scopes act like permissions assigned to an API token. These permissions determine what actions the token can perform. You can create API tokens that grant read-only access, full access, or limited access to specific endpoints by using custom scopes.

Generally, scopes are designed to match HTTP verbs and common CRUD operations (Create, Read, Update, Delete).

| HTTP Verb | CRUD Operation | Scope |
|---|---|---|
| GET | Read | `<resource>:read` |
| POST | Create | `<resource>:create` |
| PUT/PATCH | Update | `<resource>:update` |
| DELETE | Delete | `<resource>:delete` |

For example, creating a new Droplet by making a `POST` request to the `/v2/droplets` endpoint requires the `droplet:create` scope while listing Droplets by making a `GET` request to the `/v2/droplets` endpoint requires the `droplet:read` scope.

Each endpoint below specifies which scope is required to access it when using custom scopes.

#### How to Authenticate with OAuth

In order to make an authenticated request, include a bearer-type `Authorization` header containing your OAuth token. All requests must be made over HTTPS.

#### Authenticate with a Bearer Authorization Header

```
curl -X $HTTP_METHOD -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" "https://api.digitalocean.com/v2/$OBJECT"
```

To list all of the options available for the offered database engines, send a GET request to `/v2/databases/options`. The result will be a JSON object with an `options` key.

##### Request: `/v2/databases/options`

### cURL

```bash
curl -X GET \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
  "https://api.digitalocean.com/v2/databases/options"
```

### Go

```go
import (
    "context"
    "os"

    "github.com/digitalocean/godo"
)

func main() {
    token := os.Getenv("DIGITALOCEAN_TOKEN")

    client := godo.NewFromToken(token)
    ctx := context.TODO()

    options, _, err := client.Databases.ListOptions(ctx)
}
```

### Python

```python
import os
from pydo import Client

client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))

get_resp = client.databases.list_options()
```

#### Responses

**200** A JSON string with a key of options.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`options` object optional

**Show child properties**

`advanced_mysql` object optional

`advanced_pg` object optional

`kafka` object optional

`mongodb` object optional

`mysql` object optional

`opensearch` object optional

`pg` object optional

`redis` object optional

`valkey` object optional

`version_availability` object optional

**Show child properties**

`advanced_mysql` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`advanced_pg` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`kafka` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`mongodb` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`mysql` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`opensearch` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`pg` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`redis` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

`valkey` array of object optional

An array of objects, each indicating the version end-of-life, end-of-availability for various database engines

**Show child properties**

`end_of_availability` string optional Nullable

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`end_of_life` string optional Nullable

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`version` string optional

Example: `8`

The engine version.

**401** Authentication failed due to invalid credentials.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**404** The resource was not found.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**429** The API rate limit has been exceeded.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**500** There was a server error.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**default** There was an unexpected error.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

##### Response

**200**

```json
{
  "options": {
    "advanced_mysql": {
      "default_version": "8.4.8",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "gd-2vcpu-8gb-intel",
            "so1_5-2vcpu-16gb-intel",
            "so1_5-2vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb-intel",
            "so1_5-4vcpu-32gb-intel",
            "so1_5-4vcpu-32gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "gd-8vcpu-32gb-intel",
            "so1_5-8vcpu-64gb-intel",
            "gd-16vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "gd-16vcpu-64gb-intel",
            "so1_5-16vcpu-128gb-intel",
            "so1_5-24vcpu-192gb",
            "so1_5-24vcpu-192gb-intel",
            "so1_5-32vcpu-256gb-intel",
            "gd-32vcpu-128gb",
            "gd-32vcpu-128gb-intel",
            "so1_5-32vcpu-256gb",
            "gd-40vcpu-160gb",
            "so1_5-48vcpu-384gb-intel",
            "gd-48vcpu-192gb-intel",
            "so1_5-48vcpu-256gb",
            "c-96-intel"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "gd-2vcpu-8gb-intel",
            "so1_5-2vcpu-16gb-intel",
            "so1_5-2vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb-intel",
            "so1_5-4vcpu-32gb-intel",
            "so1_5-4vcpu-32gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "gd-8vcpu-32gb-intel",
            "so1_5-8vcpu-64gb-intel",
            "gd-16vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "gd-16vcpu-64gb-intel",
            "so1_5-16vcpu-128gb-intel",
            "so1_5-24vcpu-192gb",
            "so1_5-24vcpu-192gb-intel",
            "so1_5-32vcpu-256gb-intel",
            "gd-32vcpu-128gb",
            "gd-32vcpu-128gb-intel",
            "so1_5-32vcpu-256gb",
            "gd-40vcpu-160gb",
            "so1_5-48vcpu-384gb-intel",
            "gd-48vcpu-192gb-intel",
            "so1_5-48vcpu-256gb",
            "c-96-intel"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "8.4.8"
      ]
    },
    "advanced_pg": {
      "default_version": "18",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "gd-2vcpu-8gb-intel",
            "so1_5-2vcpu-16gb-intel",
            "so1_5-2vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb-intel",
            "so1_5-4vcpu-32gb-intel",
            "so1_5-4vcpu-32gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "gd-8vcpu-32gb-intel",
            "so1_5-8vcpu-64gb-intel",
            "gd-16vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "gd-16vcpu-64gb-intel",
            "so1_5-16vcpu-128gb-intel",
            "so1_5-24vcpu-192gb",
            "so1_5-24vcpu-192gb-intel",
            "so1_5-32vcpu-256gb-intel",
            "gd-32vcpu-128gb",
            "gd-32vcpu-128gb-intel",
            "so1_5-32vcpu-256gb",
            "gd-40vcpu-160gb",
            "so1_5-48vcpu-384gb-intel",
            "gd-48vcpu-192gb-intel",
            "so1_5-48vcpu-256gb",
            "c-96-intel"
          ]
        },
        {
          "num_nodes": 2,
          "sizes": [
            "gd-2vcpu-8gb-intel",
            "so1_5-2vcpu-16gb-intel",
            "so1_5-2vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb-intel",
            "so1_5-4vcpu-32gb-intel",
            "so1_5-4vcpu-32gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "gd-8vcpu-32gb-intel",
            "so1_5-8vcpu-64gb-intel",
            "gd-16vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "gd-16vcpu-64gb-intel",
            "so1_5-16vcpu-128gb-intel",
            "so1_5-24vcpu-192gb",
            "so1_5-24vcpu-192gb-intel",
            "so1_5-32vcpu-256gb-intel",
            "gd-32vcpu-128gb",
            "gd-32vcpu-128gb-intel",
            "so1_5-32vcpu-256gb",
            "gd-40vcpu-160gb",
            "so1_5-48vcpu-384gb-intel",
            "gd-48vcpu-192gb-intel",
            "so1_5-48vcpu-256gb",
            "c-96-intel"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "gd-2vcpu-8gb-intel",
            "so1_5-2vcpu-16gb-intel",
            "so1_5-2vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb-intel",
            "so1_5-4vcpu-32gb-intel",
            "so1_5-4vcpu-32gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "gd-8vcpu-32gb-intel",
            "so1_5-8vcpu-64gb-intel",
            "gd-16vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "gd-16vcpu-64gb-intel",
            "so1_5-16vcpu-128gb-intel",
            "so1_5-24vcpu-192gb",
            "so1_5-24vcpu-192gb-intel",
            "so1_5-32vcpu-256gb-intel",
            "gd-32vcpu-128gb",
            "gd-32vcpu-128gb-intel",
            "so1_5-32vcpu-256gb",
            "gd-40vcpu-160gb",
            "so1_5-48vcpu-384gb-intel",
            "gd-48vcpu-192gb-intel",
            "so1_5-48vcpu-256gb",
            "c-96-intel"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "16",
        "17",
        "18"
      ]
    },
    "kafka": {
      "default_version": "3.8",
      "layouts": [
        {
          "num_nodes": 3,
          "sizes": [
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "db-s-2vcpu-4gb",
            "db-s-2vcpu-2gb"
          ]
        },
        {
          "num_nodes": 6,
          "sizes": [
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb"
          ]
        },
        {
          "num_nodes": 9,
          "sizes": [
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb"
          ]
        },
        {
          "num_nodes": 15,
          "sizes": [
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "3.8"
      ]
    },
    "mongodb": {
      "default_version": "7.0",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "db-s-1vcpu-1gb",
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "db-s-1vcpu-1gb",
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "6.0",
        "7.0"
      ]
    },
    "mysql": {
      "default_version": "8",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "db-s-1vcpu-1gb",
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb",
            "db-intel-1vcpu-1gb",
            "db-amd-1vcpu-1gb",
            "db-intel-1vcpu-2gb",
            "db-amd-1vcpu-2gb",
            "db-amd-2vcpu-4gb",
            "db-intel-2vcpu-4gb",
            "db-amd-2vcpu-8gb",
            "db-intel-2vcpu-8gb",
            "db-intel-4vcpu-8gb",
            "db-amd-4vcpu-8gb",
            "db-amd-4vcpu-16gb",
            "db-intel-4vcpu-16gb",
            "db-intel-8vcpu-32gb",
            "db-amd-8vcpu-32gb",
            "db-intel-16vcpu-64gb",
            "db-amd-16vcpu-64gb"
          ]
        },
        {
          "num_nodes": 2,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb",
            "db-intel-1vcpu-2gb",
            "db-amd-1vcpu-2gb",
            "db-amd-2vcpu-4gb",
            "db-intel-2vcpu-4gb",
            "db-intel-2vcpu-8gb",
            "db-amd-2vcpu-8gb",
            "db-intel-4vcpu-8gb",
            "db-amd-4vcpu-8gb",
            "db-intel-4vcpu-16gb",
            "db-amd-4vcpu-16gb",
            "db-amd-8vcpu-32gb",
            "db-intel-8vcpu-32gb",
            "db-amd-16vcpu-64gb",
            "db-intel-16vcpu-64gb"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb",
            "db-intel-1vcpu-2gb",
            "db-amd-1vcpu-2gb",
            "db-amd-2vcpu-4gb",
            "db-intel-2vcpu-4gb",
            "db-intel-2vcpu-8gb",
            "db-amd-2vcpu-8gb",
            "db-intel-4vcpu-8gb",
            "db-amd-4vcpu-8gb",
            "db-intel-4vcpu-16gb",
            "db-amd-4vcpu-16gb",
            "db-amd-8vcpu-32gb",
            "db-intel-8vcpu-32gb",
            "db-amd-16vcpu-64gb",
            "db-intel-16vcpu-64gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "8"
      ]
    },
    "opensearch": {
      "default_version": "2",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "gd-2vcpu-8gb",
            "m3-2vcpu-16gb",
            "db-s-4vcpu-8gb",
            "gd-4vcpu-16gb",
            "m3-4vcpu-32gb",
            "m3-8vcpu-64gb"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "db-s-2vcpu-4gb",
            "gd-2vcpu-8gb",
            "m3-2vcpu-16gb",
            "db-s-4vcpu-8gb",
            "gd-4vcpu-16gb",
            "m3-4vcpu-32gb",
            "m3-8vcpu-64gb"
          ]
        },
        {
          "num_nodes": 6,
          "sizes": [
            "gd-2vcpu-8gb",
            "m3-2vcpu-16gb",
            "gd-4vcpu-16gb",
            "m3-4vcpu-32gb",
            "m3-8vcpu-64gb"
          ]
        },
        {
          "num_nodes": 9,
          "sizes": [
            "gd-2vcpu-8gb",
            "m3-2vcpu-16gb",
            "gd-4vcpu-16gb",
            "m3-4vcpu-32gb",
            "m3-8vcpu-64gb"
          ]
        },
        {
          "num_nodes": 15,
          "sizes": [
            "gd-2vcpu-8gb",
            "m3-2vcpu-16gb",
            "gd-4vcpu-16gb",
            "m3-4vcpu-32gb",
            "m3-8vcpu-64gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "1",
        "2"
      ]
    },
    "pg": {
      "default_version": "17",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "db-s-1vcpu-1gb",
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb",
            "db-intel-1vcpu-1gb",
            "db-amd-1vcpu-1gb",
            "db-intel-1vcpu-2gb",
            "db-amd-1vcpu-2gb",
            "db-amd-2vcpu-4gb",
            "db-intel-2vcpu-4gb",
            "db-amd-2vcpu-8gb",
            "db-intel-2vcpu-8gb",
            "db-intel-4vcpu-8gb",
            "db-amd-4vcpu-8gb",
            "db-amd-4vcpu-16gb",
            "db-intel-4vcpu-16gb",
            "db-intel-8vcpu-32gb",
            "db-amd-8vcpu-32gb",
            "db-intel-16vcpu-64gb",
            "db-amd-16vcpu-64gb"
          ]
        },
        {
          "num_nodes": 2,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb",
            "db-intel-1vcpu-2gb",
            "db-amd-1vcpu-2gb",
            "db-amd-2vcpu-4gb",
            "db-intel-2vcpu-4gb",
            "db-intel-2vcpu-8gb",
            "db-amd-2vcpu-8gb",
            "db-intel-4vcpu-8gb",
            "db-amd-4vcpu-8gb",
            "db-intel-4vcpu-16gb",
            "db-amd-4vcpu-16gb",
            "db-amd-8vcpu-32gb",
            "db-intel-8vcpu-32gb",
            "db-amd-16vcpu-64gb",
            "db-intel-16vcpu-64gb"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "gd-2vcpu-8gb",
            "gd-4vcpu-16gb",
            "gd-8vcpu-32gb",
            "gd-16vcpu-64gb",
            "gd-32vcpu-128gb",
            "gd-40vcpu-160gb",
            "so1_5-2vcpu-16gb",
            "so1_5-4vcpu-32gb",
            "so1_5-8vcpu-64gb",
            "so1_5-16vcpu-128gb",
            "so1_5-24vcpu-192gb",
            "so1_5-32vcpu-256gb",
            "db-intel-1vcpu-2gb",
            "db-amd-1vcpu-2gb",
            "db-amd-2vcpu-4gb",
            "db-intel-2vcpu-4gb",
            "db-intel-2vcpu-8gb",
            "db-amd-2vcpu-8gb",
            "db-intel-4vcpu-8gb",
            "db-amd-4vcpu-8gb",
            "db-intel-4vcpu-16gb",
            "db-amd-4vcpu-16gb",
            "db-amd-8vcpu-32gb",
            "db-intel-8vcpu-32gb",
            "db-amd-16vcpu-64gb",
            "db-intel-16vcpu-64gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "13",
        "14",
        "15",
        "16",
        "17"
      ]
    },
    "redis": {
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "db-s-1vcpu-1gb",
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "m-2vcpu-16gb",
            "m-4vcpu-32gb",
            "m-8vcpu-64gb",
            "m-16vcpu-128gb",
            "m-24vcpu-192gb",
            "m-32vcpu-256gb"
          ]
        },
        {
          "num_nodes": 2,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "m-2vcpu-16gb",
            "m-4vcpu-32gb",
            "m-8vcpu-64gb",
            "m-16vcpu-128gb",
            "m-24vcpu-192gb",
            "m-32vcpu-256gb"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "m-2vcpu-16gb",
            "m-4vcpu-32gb",
            "m-8vcpu-64gb",
            "m-16vcpu-128gb",
            "m-24vcpu-192gb",
            "m-32vcpu-256gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc2",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "7"
      ]
    },
    "valkey": {
      "default_version": "8",
      "layouts": [
        {
          "num_nodes": 1,
          "sizes": [
            "db-s-1vcpu-1gb",
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "m-2vcpu-16gb",
            "m-4vcpu-32gb",
            "m-8vcpu-64gb",
            "m-16vcpu-128gb",
            "m-24vcpu-192gb",
            "m-32vcpu-256gb"
          ]
        },
        {
          "num_nodes": 2,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "m-2vcpu-16gb",
            "m-4vcpu-32gb",
            "m-8vcpu-64gb",
            "m-16vcpu-128gb",
            "m-24vcpu-192gb",
            "m-32vcpu-256gb"
          ]
        },
        {
          "num_nodes": 3,
          "sizes": [
            "db-s-1vcpu-2gb",
            "db-s-2vcpu-4gb",
            "db-s-4vcpu-8gb",
            "db-s-6vcpu-16gb",
            "db-s-8vcpu-32gb",
            "db-s-16vcpu-64gb",
            "m-2vcpu-16gb",
            "m-4vcpu-32gb",
            "m-8vcpu-64gb",
            "m-16vcpu-128gb",
            "m-24vcpu-192gb",
            "m-32vcpu-256gb"
          ]
        }
      ],
      "regions": [
        "ams3",
        "blr1",
        "fra1",
        "lon1",
        "nyc1",
        "nyc3",
        "sfo2",
        "sfo3",
        "sgp1",
        "syd1",
        "tor1",
        "ric1",
        "atl1"
      ],
      "versions": [
        "8"
      ]
    }
  },
  "version_availability": {
    "advanced_mysql": [
      {
        "default": true,
        "end_of_availability": null,
        "end_of_life": null,
        "version": "8.4.8"
      }
    ],
    "advanced_pg": [
      {
        "default": false,
        "end_of_availability": "2028-05-09T00:00:00Z",
        "end_of_life": "2028-11-09T00:00:00Z",
        "version": "16"
      },
      {
        "default": false,
        "end_of_availability": "2029-05-08T00:00:00Z",
        "end_of_life": "2029-11-08T00:00:00Z",
        "version": "17"
      },
      {
        "default": true,
        "end_of_availability": "2030-05-13T00:00:00Z",
        "end_of_life": "2030-11-13T00:00:00Z",
        "version": "18"
      }
    ],
    "kafka": [
      {
        "default": true,
        "end_of_availability": "2025-06-03T00:00:00Z",
        "end_of_life": null,
        "version": "3.8"
      }
    ],
    "mongodb": [
      {
        "default": false,
        "end_of_availability": null,
        "end_of_life": "2025-07-01T07:00:00Z",
        "version": "6.0"
      },
      {
        "default": true,
        "end_of_availability": null,
        "end_of_life": "2026-08-01T07:00:00Z",
        "version": "7.0"
      }
    ],
    "mysql": [
      {
        "default": true,
        "end_of_availability": null,
        "end_of_life": null,
        "version": "8"
      }
    ],
    "opensearch": [
      {
        "default": false,
        "end_of_availability": null,
        "end_of_life": null,
        "version": "1"
      },
      {
        "default": true,
        "end_of_availability": null,
        "end_of_life": null,
        "version": "2"
      }
    ],
    "pg": [
      {
        "default": false,
        "end_of_availability": "2025-05-13T00:00:00Z",
        "end_of_life": "2025-11-13T00:00:00Z",
        "version": "13"
      },
      {
        "default": false,
        "end_of_availability": "2026-05-12T00:00:00Z",
        "end_of_life": "2026-11-12T00:00:00Z",
        "version": "14"
      },
      {
        "default": false,
        "end_of_availability": "2027-05-12T00:00:00Z",
        "end_of_life": "2027-11-11T00:00:00Z",
        "version": "15"
      },
      {
        "default": false,
        "end_of_availability": "2028-05-09T00:00:00Z",
        "end_of_life": "2028-11-09T00:00:00Z",
        "version": "16"
      },
      {
        "default": true,
        "end_of_availability": "2029-05-08T00:00:00Z",
        "end_of_life": "2029-11-08T00:00:00Z",
        "version": "17"
      }
    ],
    "redis": [
      {
        "default": true,
        "end_of_availability": "2025-04-30T00:00:00Z",
        "end_of_life": "2025-06-30T00:00:00Z",
        "version": "7"
      }
    ],
    "valkey": [
      {
        "default": true,
        "end_of_availability": null,
        "end_of_life": null,
        "version": "8"
      }
    ]
  }
}
```

**401**

```json
{
  "id": "unauthorized",
  "message": "Unable to authenticate you."
}
```

**404**

```json
{
  "id": "not_found",
  "message": "The resource you requested could not be found."
}
```

**429**

```json
{
  "id": "too_many_requests",
  "message": "API rate limit exceeded."
}
```

**500**

```json
{
  "id": "server_error",
  "message": "Unexpected server-side error"
}
```

**default**

```json
{
  "id": "example_error",
  "message": "some error message"
}
```

* * *

## GET List All Database Clusters

`/v2/databases`

To list all of the database clusters available on your account, send a GET request to `/v2/databases`. To limit the results to database clusters with a specific tag, include the `tag_name` query parameter set to the name of the tag. For example, `/v2/databases?tag_name=$TAG_NAME`.

The result will be a JSON object with a `databases` key. This will be set to an array of database objects, each of which will contain the standard database attributes.

The embedded `connection` and `private_connection` objects will contain the information needed to access the database cluster. For multi-node clusters, the `standby_connection` and `standby_private_connection` objects will contain the information needed to connect to the cluster's standby node(s).

The embedded `maintenance_window` object will contain information about any scheduled maintenance for the database cluster.

#### Query Parameters

`tag_name` string optional

Example: `production`

Limits the results to database clusters with a specific tag.

Requires `tag:read` scope.

##### Request: `/v2/databases`

### cURL

```bash
curl -X GET \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
  "https://api.digitalocean.com/v2/databases"
```

### Go

```go
import (
    "context"
    "os"

    "github.com/digitalocean/godo"
)

func main() {
    token := os.Getenv("DIGITALOCEAN_TOKEN")

    client := godo.NewFromToken(token)
    ctx := context.TODO()

    opt := &godo.ListOptions{
        Page:    1,
        PerPage: 200,
    }

    clusters, _, err := client.Databases.List(ctx, opt)
}
```

### Python

```python
import os
from pydo import Client

client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))

get_resp = client.databases.list_clusters(tag_name="production")
```

#### Responses

**200** A JSON object with a key of databases.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`databases` array of object optional

**Show child properties**

`connection` object optional

`created_at` string (date-time) optional read-only

Example: `2019-01-11T18:37:36Z`

A time value given in ISO8601 combined date and time format that represents when the database cluster was created.

`db_names` array of string optional read-only Nullable

Example: `["doadmin"]`

An array of strings containing the names of databases created in the database cluster.

`do_settings` object optional

`engine` string (enum) required

Example: `mysql`

A slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, "valkey" for Valkey, "advanced_pg" for PostgreSQL Advanced Edition, and "advanced_mysql" for MySQL Advanced Edition. Advanced Edition engines are currently in public preview.

`id` string (uuid) optional read-only

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

A unique ID that can be used to identify and reference a database cluster.

`maintenance_window` object optional

`metrics_endpoints` array of object optional read-only

Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).

**Show child properties**

`host` string optional read-only

Example: `db.example.com`

A FQDN pointing to the database cluster's node(s).

`port` integer optional read-only

Example: `9273`

The port on which a service is listening.

`name` string required

Example: `backend`

A unique, human-readable name referring to a database cluster.

`num_nodes` integer required

Example: `2`

The number of nodes in the database cluster.

`private_connection` object optional

`private_network_uuid` string optional

Example: `d455e75d-4858-4eec-8c95-da2f0a5f93a7`

A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.

Requires `vpc:read` scope.

`project_id` string (uuid) optional

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

The ID of the project that the database cluster is assigned to. If excluded when creating a new database cluster, it will be assigned to your default project.

Requires `project:read` scope.

`region` string required

Example: `nyc3`

The slug identifier for the region where the database cluster is located.

`rules` array of object optional

**Show child properties**

`cluster_uuid` string optional read-only

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

A unique ID for the database cluster to which the rule is applied.

`created_at` string (date-time) optional read-only

Example: `2019-01-11T18:37:36Z`

A time value given in ISO8601 combined date and time format that represents when the firewall rule was created.

`description` string optional

Example: `an IP address for local development`

A human-readable description of the rule.

`type` string, one of: droplet, k8s, ip_addr, tag, app required

Example: `droplet`

The type of resource that the firewall rule allows to access the database cluster.

`uuid` string optional

Example: `79f26d28-ea8a-41f2-8ad8-8cfcdd020095`

A unique ID for the firewall rule itself.

`value` string required

Example: `ff2a6c52-5a44-4b63-b99c-0e98e7a63d61`

The ID of the specific resource, the name of a tag applied to a group of resources, or the IP address that the firewall rule allows to access the database cluster.

`schema_registry_connection` object optional

The connection details for Schema Registry.

`semantic_version` string optional read-only

Example: `8.0.28`

A string representing the semantic version of the database engine in use for the cluster.

`size` string required

Example: `db-s-2vcpu-4gb`

The slug identifier representing the size of the nodes in the database cluster.

`standby_connection` object optional

`standby_private_connection` object optional

`status` string, one of: creating, online, resizing, migrating, forking optional read-only

Example: `creating`

A string representing the current status of the database cluster.

`storage_size_mib` integer optional

Example: `61440`

Additional storage added to the cluster, in MiB. If null, no additional storage is added to the cluster, beyond what is provided as a base amount from the 'size' and any previously added additional storage.

`tags` array of string optional Nullable

Example: `["production"]`

An array of tags that have been applied to the database cluster.

Requires `tag:read` scope.

`ui_connection` object optional

The connection details for OpenSearch dashboard.

`users` array of object optional read-only Nullable

**Show child properties**

`access_cert` string optional read-only

Access certificate for TLS client authentication. (Kafka only)

`access_key` string optional read-only

Access key for TLS client authentication. (Kafka only)

`mysql_settings` object optional

**Show child properties**

`auth_plugin` string, one of: mysql_native_password, caching_sha2_password required

Example: `mysql_native_password`

A string specifying the authentication method to be used for connections to the MySQL user account. The valid values are `mysql_native_password` or `caching_sha2_password`. If excluded when creating a new user, the default for the version of MySQL in use will be used. As of MySQL 8.0, the default is `caching_sha2_password`.

`name` string required

Example: `app-01`

The name of a database user.

`password` string optional read-only

Example: `example_password`

A randomly generated password for the database user.
Requires `database:view_credentials` scope.

`role` string, one of: primary, normal optional read-only

Example: `normal`

A string representing the database user's role. The value will be either "primary" or "normal".

`settings` object optional

**Show child properties**

`acl` array of object optional

ACLs (Access Control Lists) specifying permissions on topics within a Kafka cluster.

*Additional nested properties not shown. Refer to the [full API spec](https://github.com/digitalocean/openapi) for details.*

`mongo_user_settings` object optional

MongoDB-specific settings for the user. Configure these when creating a user. Updating MongoDB roles or database access after creation is not supported; recreate the user to change them. This option is not currently supported for other database engines.

*Additional nested properties not shown. Refer to the [full API spec](https://github.com/digitalocean/openapi) for details.*

`opensearch_acl` array of object optional

ACLs (Access Control Lists) specifying permissions on index within a OpenSearch cluster.

*Additional nested properties not shown. Refer to the [full API spec](https://github.com/digitalocean/openapi) for details.*

`pg_allow_replication` boolean optional

Example: `true`

For PostgreSQL clusters, set to `true` to grant the user replication privileges. When omitted on create or update, the value defaults to `false` and replication privileges are not granted. This option is not currently supported for other database engines.

`version` string optional

Example: `8`

A string representing the version of the database engine in use for the cluster.

`version_end_of_availability` string optional read-only

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`version_end_of_life` string optional read-only

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

**401** Authentication failed due to invalid credentials.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**404** The resource was not found.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**429** The API rate limit has been exceeded.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**500** There was a server error.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**default** There was an unexpected error.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

##### Response

**200**

```json
{
  "databases": [
    {
      "connection": {
        "database": "",
        "host": "db.example.com",
        "password": "example_password",
        "port": 25060,
        "ssl": true,
        "uri": "postgres://doadmin:example_password@db.example.com:25060/defaultdb?sslmode=require",
        "user": "doadmin"
      },
      "created_at": "2019-01-11T18:37:36Z",
      "db_names": [
        "defaultdb"
      ],
      "engine": "pg",
      "id": "9cc10173-e9ea-4176-9dbc-a4cee4c4ff30",
      "maintenance_window": {
        "day": "saturday",
        "description": [
          "Update TimescaleDB to version 1.2.1",
          "Upgrade to PostgreSQL 11.2 and 10.7 bugfix releases"
        ],
        "hour": "08:45:12",
        "pending": true
      },
      "name": "backend",
      "num_nodes": 1,
      "private_connection": {
        "database": "",
        "host": "private-db.example.com",
        "password": "example_password",
        "port": 25060,
        "ssl": true,
        "uri": "postgres://doadmin:example_password@private-db.example.com:25060/defaultdb?sslmode=require",
        "user": "doadmin"
      },
      "private_network_uuid": "d455e75d-4858-4eec-8c95-da2f0a5f93a7",
      "region": "nyc3",
      "size": "db-s-2vcpu-4gb",
      "status": "online",
      "storage_size_mib": 61440,
      "tags": [
        "production"
      ],
      "users": [
        {
          "name": "doadmin",
          "password": "example_password",
          "role": "primary"
        }
      ],
      "version": "10",
      "version_end_of_availability": "2023-05-09T00:00:00Z",
      "version_end_of_life": "2023-11-09T00:00:00Z"
    }
  ]
}
```

**401**

```json
{
  "id": "unauthorized",
  "message": "Unable to authenticate you."
}
```

**404**

```json
{
  "id": "not_found",
  "message": "The resource you requested could not be found."
}
```

**429**

```json
{
  "id": "too_many_requests",
  "message": "API rate limit exceeded."
}
```

**500**

```json
{
  "id": "server_error",
  "message": "Unexpected server-side error"
}
```

**default**

```json
{
  "id": "example_error",
  "message": "some error message"
}
```

* * *

## POST Create a New Database Cluster

`/v2/databases`

To create a database cluster, send a POST request to `/v2/databases`. To see a list of options for each engine, such as available regions, size slugs, and versions, send a GET request to the `/v2/databases/options` endpoint. The available sizes for the `storage_size_mib` field depends on the cluster's size. To see a list of available sizes, see [Managed Database Pricing](https://www.digitalocean.com/pricing/managed-databases).

The create response returns a JSON object with a key called `database`. The value of this is an object that contains the standard attributes associated with a database cluster. The initial value of the database cluster's `status` attribute is `creating`. When the cluster is ready to receive traffic, this changes to `online`.

The embedded `connection` and `private_connection` objects contains the information needed to access the database cluster. For multi-node clusters, the `standby_connection` and `standby_private_connection` objects contain the information needed to connect to the cluster's standby node(s).

DigitalOcean managed PostgreSQL and MySQL database clusters take automated daily backups. To create a new database cluster based on a backup of an existing cluster, send a POST request to `/v2/databases`. In addition to the standard database cluster attributes, the JSON body must include a key named `backup_restore` with the name of the original database cluster and the timestamp of the backup to be restored. Creating a database from a backup is the same as forking a database in the control panel.

PostgreSQL and MySQL Advanced Edition clusters can be provisioned by setting `engine` to `advanced_pg` or `advanced_mysql`. Advanced Edition clusters are currently in public preview and target highly available workloads. `advanced_pg` supports 1-, 2-, and 3-node deployments; `advanced_mysql` only supports 1- and 3-node deployments. See the [PostgreSQL Advanced Edition](https://docs.digitalocean.com/products/databases/postgresql/how-to/use-advanced-edition-clusters/index.html.md) and [MySQL Advanced Edition](https://docs.digitalocean.com/products/databases/mysql/how-to/use-advanced-edition-clusters/index.html.md) documentation for the feature differences vs. Standard Edition and current preview limitations.

Note: Caching cluster creates are no longer supported as of 2025-04-30T00:00:00Z. Backups are also not supported for Caching or Valkey clusters.

#### Request Body: `application/json`

`autoscale` object optional

Autoscaling configuration for the database cluster. Currently only supports storage autoscaling. If null, autoscaling is not configured for the cluster.

`connection` object optional

`created_at` string (date-time) optional read-only

Example: `2019-01-11T18:37:36Z`

A time value given in ISO8601 combined date and time format that represents when the database cluster was created.

`db_names` array of string optional read-only Nullable

Example: `["doadmin"]`

An array of strings containing the names of databases created in the database cluster.

`do_settings` object optional

`engine` string (enum) required

Example: `mysql`

A slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, "valkey" for Valkey, "advanced_pg" for PostgreSQL Advanced Edition, and "advanced_mysql" for MySQL Advanced Edition. Advanced Edition engines are currently in public preview.

`id` string (uuid) optional read-only

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

A unique ID that can be used to identify and reference a database cluster.

`maintenance_window` object optional

`metrics_endpoints` array of object optional read-only

Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).

**Show child properties**

`host` string optional read-only

Example: `db.example.com`

A FQDN pointing to the database cluster's node(s).

`port` integer optional read-only

Example: `9273`

The port on which a service is listening.

`name` string required

Example: `backend`

A unique, human-readable name referring to a database cluster.

`num_nodes` integer required

Example: `2`

The number of nodes in the database cluster.

`private_connection` object optional

`private_network_uuid` string optional

Example: `d455e75d-4858-4eec-8c95-da2f0a5f93a7`

A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.

Requires `vpc:read` scope.

`project_id` string (uuid) optional

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

The ID of the project that the database cluster is assigned to. If excluded when creating a new database cluster, it will be assigned to your default project.

Requires `project:assign_resource` scope.

`region` string required

Example: `nyc3`

The slug identifier for the region where the database cluster is located.

`rules` array of object optional

**Show child properties**

`cluster_uuid` string optional read-only

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

A unique ID for the database cluster to which the rule is applied.

`created_at` string (date-time) optional read-only

Example: `2019-01-11T18:37:36Z`

A time value given in ISO8601 combined date and time format that represents when the firewall rule was created.

`description` string optional

Example: `an IP address for local development`

A human-readable description of the rule.

`type` string, one of: droplet, k8s, ip_addr, tag, app required

Example: `droplet`

The type of resource that the firewall rule allows to access the database cluster.

`uuid` string optional

Example: `79f26d28-ea8a-41f2-8ad8-8cfcdd020095`

A unique ID for the firewall rule itself.

`value` string required

Example: `ff2a6c52-5a44-4b63-b99c-0e98e7a63d61`

The ID of the specific resource, the name of a tag applied to a group of resources, or the IP address that the firewall rule allows to access the database cluster.

`schema_registry_connection` object optional

The connection details for Schema Registry.

`semantic_version` string optional read-only

Example: `8.0.28`

A string representing the semantic version of the database engine in use for the cluster.

`size` string required

Example: `db-s-2vcpu-4gb`

The slug identifier representing the size of the nodes in the database cluster.

`standby_connection` object optional

`standby_private_connection` object optional

`status` string, one of: creating, online, resizing, migrating, forking optional read-only

Example: `creating`

A string representing the current status of the database cluster.

`storage_size_mib` integer optional

Example: `61440`

Additional storage added to the cluster, in MiB. If null, no additional storage is added to the cluster, beyond what is provided as a base amount from the 'size' and any previously added additional storage.

`tags` array of string optional Nullable

Example: `["production"]`

An array of tags (as strings) to apply to the database cluster.

Requires `tag:create` scope.

`ui_connection` object optional

The connection details for OpenSearch dashboard.

`users` array of object optional read-only Nullable

**Show child properties**

`access_cert` string optional read-only

Access certificate for TLS client authentication. (Kafka only)

`access_key` string optional read-only

Access key for TLS client authentication. (Kafka only)

`mysql_settings` object optional

**Show child properties**

`auth_plugin` string, one of: mysql_native_password, caching_sha2_password required

Example: `mysql_native_password`

A string specifying the authentication method to be used for connections to the MySQL user account. The valid values are `mysql_native_password` or `caching_sha2_password`. If excluded when creating a new user, the default for the version of MySQL in use will be used. As of MySQL 8.0, the default is `caching_sha2_password`.

`name` string required

Example: `app-01`

The name of a database user.

`password` string optional read-only

Example: `example_password`

A randomly generated password for the database user.
Requires `database:view_credentials` scope.

`role` string, one of: primary, normal optional read-only

Example: `normal`

A string representing the database user's role. The value will be either "primary" or "normal".

`settings` object optional

**Show child properties**

`acl` array of object optional

ACLs (Access Control Lists) specifying permissions on topics within a Kafka cluster.

**Show child properties**

`id` string optional

Example: `aaa`

An identifier for the ACL. Will be computed after the ACL is created/updated.

`permission` string, one of: admin, consume, produce, produceconsume required

Example: `consume`

Permission set applied to the ACL. 'consume' allows for messages to be consumed from the topic. 'produce' allows for messages to be published to the topic. 'produceconsume' allows for both 'consume' and 'produce' permission. 'admin' allows for 'produceconsume' as well as any operations to administer the topic (delete, update).

`topic` string required

Example: `topic-abc.*`

A regex for matching the topic(s) that this ACL should apply to.

`mongo_user_settings` object optional

MongoDB-specific settings for the user. Configure these when creating a user. Updating MongoDB roles or database access after creation is not supported; recreate the user to change them. This option is not currently supported for other database engines.

**Show child properties**

`databases` array of string optional

Example: `["my-db","my-db-2"]`

A list of databases to which the user should have access. When the database is set to `admin`, the user will have access to all databases based on the user's role i.e. a user with the role `readOnly` assigned to the `admin` database will have read access to all databases.

`role` string, one of: readOnly, readWrite, dbAdmin optional

Example: `readOnly`

The role to assign to the user with each role mapping to a MongoDB built-in role. `readOnly` maps to a [read](https://www.mongodb.com/docs/manual/reference/built-in-roles/#mongodb-authrole-read) role. `readWrite` maps to a [readWrite](https://www.mongodb.com/docs/manual/reference/built-in-roles/#mongodb-authrole-readWrite) role. `dbAdmin` maps to a [dbAdmin](https://www.mongodb.com/docs/manual/reference/built-in-roles/#mongodb-authrole-dbAdmin) role.

`opensearch_acl` array of object optional

ACLs (Access Control Lists) specifying permissions on index within a OpenSearch cluster.

**Show child properties**

`index` string optional

Example: `index-abc.*`

A regex for matching the indexes that this ACL should apply to.

`permission` string, one of: deny, admin, read, readwrite, write optional

Example: `read`

Permission set applied to the ACL. 'read' allows user to read from the index. 'write' allows for user to write to the index. 'readwrite' allows for both 'read' and 'write' permission. 'deny'(default) restricts user from performing any operation over an index. 'admin' allows for 'readwrite' as well as any operations to administer the index.

`pg_allow_replication` boolean optional

Example: `true`

For PostgreSQL clusters, set to `true` to grant the user replication privileges. When omitted on create or update, the value defaults to `false` and replication privileges are not granted. This option is not currently supported for other database engines.

`version` string optional

Example: `8`

A string representing the version of the database engine in use for the cluster.

`version_end_of_availability` string optional read-only

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`version_end_of_life` string optional read-only

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

`backup_restore` object optional

**Show child properties**

`backup_created_at` string (date-time) optional

Example: `2019-01-31T19:25:22Z`

The timestamp of an existing database cluster backup in ISO8601 combined date and time format. The most recent backup will be used if excluded.

`database_name` string required

Example: `backend`

The name of an existing database cluster from which the backup will be restored.

##### Request: `/v2/databases`

### Payload

Content type `application/json`

Example

```json
{
  "engine": "pg",
  "name": "backend",
  "num_nodes": 2,
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "version": "14"
}
```

```json
{
  "do_settings": {
    "service_cnames": [
      "db.example.com",
      "database.myapp.io"
    ]
  },
  "engine": "pg",
  "name": "backend",
  "num_nodes": 2,
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "version": "14"
}
```

```json
{
  "engine": "pg",
  "name": "backend",
  "num_nodes": 2,
  "region": "nyc3",
  "rules": [
    {
      "type": "ip_addr",
      "value": "192.168.1.1"
    },
    {
      "type": "k8s",
      "value": "ff2a6c52-5a44-4b63-b99c-0e98e7a63d61"
    },
    {
      "type": "droplet",
      "value": "163973392"
    },
    {
      "description": "a test tag",
      "type": "tag",
      "value": "test"
    }
  ],
  "size": "db-s-2vcpu-4gb",
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "version": "14"
}
```

```json
{
  "engine": "advanced_mysql",
  "name": "backend-advanced",
  "num_nodes": 3,
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "version": "8.4.8"
}
```

```json
{
  "engine": "advanced_pg",
  "name": "backend-advanced",
  "num_nodes": 3,
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "version": "18"
}
```

```json
{
  "engine": "advanced_mysql",
  "name": "backend-advanced-single",
  "num_nodes": 1,
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "version": "8.4.8"
}
```

```json
{
  "backup_restore": {
    "backup_created_at": "2019-01-31T19:25:22Z",
    "database_name": "backend"
  },
  "engine": "pg",
  "name": "backend-restored",
  "num_nodes": 2,
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "version": "14"
}
```

### cURL

```bash
curl -X POST \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $DIGITALOCEAN_TOKEN" \
  -d '{"name": "backend", "engine": "pg", "version": "14", "region": "nyc3", "size": "db-s-2vcpu-4gb", "num_nodes": 2, "storage_size_mib": 61440, "tags": ["production"], "do_settings": {"service_cnames": ["db.example.com", "database.myapp.io"]}}' \
  "https://api.digitalocean.com/v2/databases"
```

### Go

```go
import (
    "context"
    "os"

    "github.com/digitalocean/godo"
)

func main() {
    token := os.Getenv("DIGITALOCEAN_TOKEN")

    client := godo.NewFromToken(token)
    ctx := context.TODO()

    createRequest := &godo.DatabaseCreateRequest{
        Name:       "backend",
        EngineSlug: "pg",
        Version:    "14",
        Region:     "nyc3",
        SizeSlug:   "db-s-2vcpu-4gb",
        NumNodes:   2,
        StorageSizeMiB : 61440,
        DOSettings: &godo.DOSettings{
            ServiceCnames: []string{"db.example.com", "database.myapp.io"},
        },
    }

    cluster, _, err := client.Databases.Create(ctx, createRequest)
}
```

### Python

```python
import os
from pydo import Client

client = Client(token=os.environ.get("DIGITALOCEAN_TOKEN"))

create_req = {
  "name": "backend",
  "engine": "pg",
  "version": "14",
  "region": "nyc3",
  "size": "db-s-2vcpu-4gb",
  "num_nodes": 2,
  "storage_size_mib": 61440,
  "tags": [
    "production"
  ],
  "do_settings": {
    "service_cnames": [
      "db.example.com",
      "database.myapp.io"
    ]
  }
}

create_resp = client.databases.create_cluster(body=create_req)
```

#### Responses

**201** A JSON object with a key of database.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`database` object required

**Show child properties**

`connection` object optional

`created_at` string (date-time) optional read-only

Example: `2019-01-11T18:37:36Z`

A time value given in ISO8601 combined date and time format that represents when the database cluster was created.

`db_names` array of string optional read-only Nullable

Example: `["doadmin"]`

An array of strings containing the names of databases created in the database cluster.

`do_settings` object optional

`engine` string (enum) required

Example: `mysql`

A slug representing the database engine used for the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis" for Caching, "mongodb" for MongoDB, "kafka" for Kafka, "opensearch" for OpenSearch, "valkey" for Valkey, "advanced_pg" for PostgreSQL Advanced Edition, and "advanced_mysql" for MySQL Advanced Edition. Advanced Edition engines are currently in public preview.

`id` string (uuid) optional read-only

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

A unique ID that can be used to identify and reference a database cluster.

`maintenance_window` object optional

`metrics_endpoints` array of object optional read-only

Public hostname and port of the cluster's metrics endpoint(s). Includes one record for the cluster's primary node and a second entry for the cluster's standby node(s).

**Show child properties**

`host` string optional read-only

Example: `db.example.com`

A FQDN pointing to the database cluster's node(s).

`port` integer optional read-only

Example: `9273`

The port on which a service is listening.

`name` string required

Example: `backend`

A unique, human-readable name referring to a database cluster.

`num_nodes` integer required

Example: `2`

The number of nodes in the database cluster.

`private_connection` object optional

`private_network_uuid` string optional

Example: `d455e75d-4858-4eec-8c95-da2f0a5f93a7`

A string specifying the UUID of the VPC to which the database cluster will be assigned. If excluded, the cluster when creating a new database cluster, it will be assigned to your account's default VPC for the region.

Requires `vpc:read` scope.

`project_id` string (uuid) optional

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

The ID of the project that the database cluster is assigned to. If excluded when creating a new database cluster, it will be assigned to your default project.

Requires `project:read` scope.

`region` string required

Example: `nyc3`

The slug identifier for the region where the database cluster is located.

`rules` array of object optional

**Show child properties**

`cluster_uuid` string optional read-only

Example: `9cc10173-e9ea-4176-9dbc-a4cee4c4ff30`

A unique ID for the database cluster to which the rule is applied.

`created_at` string (date-time) optional read-only

Example: `2019-01-11T18:37:36Z`

A time value given in ISO8601 combined date and time format that represents when the firewall rule was created.

`description` string optional

Example: `an IP address for local development`

A human-readable description of the rule.

`type` string, one of: droplet, k8s, ip_addr, tag, app required

Example: `droplet`

The type of resource that the firewall rule allows to access the database cluster.

`uuid` string optional

Example: `79f26d28-ea8a-41f2-8ad8-8cfcdd020095`

A unique ID for the firewall rule itself.

`value` string required

Example: `ff2a6c52-5a44-4b63-b99c-0e98e7a63d61`

The ID of the specific resource, the name of a tag applied to a group of resources, or the IP address that the firewall rule allows to access the database cluster.

`schema_registry_connection` object optional

The connection details for Schema Registry.

`semantic_version` string optional read-only

Example: `8.0.28`

A string representing the semantic version of the database engine in use for the cluster.

`size` string required

Example: `db-s-2vcpu-4gb`

The slug identifier representing the size of the nodes in the database cluster.

`standby_connection` object optional

`standby_private_connection` object optional

`status` string, one of: creating, online, resizing, migrating, forking optional read-only

Example: `creating`

A string representing the current status of the database cluster.

`storage_size_mib` integer optional

Example: `61440`

Additional storage added to the cluster, in MiB. If null, no additional storage is added to the cluster, beyond what is provided as a base amount from the 'size' and any previously added additional storage.

`tags` array of string optional Nullable

Example: `["production"]`

An array of tags that have been applied to the database cluster.

Requires `tag:read` scope.

`ui_connection` object optional

The connection details for OpenSearch dashboard.

`users` array of object optional read-only Nullable

**Show child properties**

`access_cert` string optional read-only

Access certificate for TLS client authentication. (Kafka only)

`access_key` string optional read-only

Access key for TLS client authentication. (Kafka only)

`mysql_settings` object optional

**Show child properties**

`auth_plugin` string, one of: mysql_native_password, caching_sha2_password required

Example: `mysql_native_password`

A string specifying the authentication method to be used for connections to the MySQL user account. The valid values are `mysql_native_password` or `caching_sha2_password`. If excluded when creating a new user, the default for the version of MySQL in use will be used. As of MySQL 8.0, the default is `caching_sha2_password`.

`name` string required

Example: `app-01`

The name of a database user.

`password` string optional read-only

Example: `example_password`

A randomly generated password for the database user.
Requires `database:view_credentials` scope.

`role` string, one of: primary, normal optional read-only

Example: `normal`

A string representing the database user's role. The value will be either "primary" or "normal".

`settings` object optional

**Show child properties**

`acl` array of object optional

ACLs (Access Control Lists) specifying permissions on topics within a Kafka cluster.

*Additional nested properties not shown. Refer to the [full API spec](https://github.com/digitalocean/openapi) for details.*

`mongo_user_settings` object optional

MongoDB-specific settings for the user. Configure these when creating a user. Updating MongoDB roles or database access after creation is not supported; recreate the user to change them. This option is not currently supported for other database engines.

*Additional nested properties not shown. Refer to the [full API spec](https://github.com/digitalocean/openapi) for details.*

`opensearch_acl` array of object optional

ACLs (Access Control Lists) specifying permissions on index within a OpenSearch cluster.

*Additional nested properties not shown. Refer to the [full API spec](https://github.com/digitalocean/openapi) for details.*

`pg_allow_replication` boolean optional

Example: `true`

For PostgreSQL clusters, set to `true` to grant the user replication privileges. When omitted on create or update, the value defaults to `false` and replication privileges are not granted. This option is not currently supported for other database engines.

`version` string optional

Example: `8`

A string representing the version of the database engine in use for the cluster.

`version_end_of_availability` string optional read-only

Example: `2023-05-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be available for creating new clusters. If null, the version does not have an end of availability timeline.

`version_end_of_life` string optional read-only

Example: `2023-11-09T00:00:00Z`

A timestamp referring to the date when the particular version will no longer be supported. If null, the version does not have an end of life timeline.

**401** Authentication failed due to invalid credentials.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

A message providing additional information about the error, including details to help resolve it when possible.

`request_id` string optional

Example: `4d9d8375-3c56-4925-a3e7-eb137fed17e9`

Optionally, some endpoints may include a request ID that should be provided when reporting bugs or opening support tickets to help identify the issue.

**404** The resource was not found.

Response Headers

`ratelimit-limit` integer

The default limit on number of requests that can be made per hour and per minute. Current rate limits are 5000 requests per hour and 250 requests per minute.

`ratelimit-remaining` integer

The number of requests in your hourly quota that remain before you hit your request limit. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

`ratelimit-reset` integer

The time when the oldest request will expire. The value is given in Unix epoch time. See [https://docs.digitalocean.com/reference/api/reference/#rate-limit](https://docs.digitalocean.com/reference/api/reference/index.html.md#rate-limit) for information about how requests expire.

Response Schema: `application/json`

`id` string required

Example: `not_found`

A short identifier corresponding to the HTTP status code returned. For example, the ID for a response returning a 404 status code would be "not_found."

`message` string required

Example: `The resource you were accessing could not be found.`

[...]
